-- =============================================================================================================
-- *
-- * Copyright (c) University of York
-- *
-- * File Name: DE3_Wrapper_tb.vhd
-- *
-- * Version: V1.0
-- *
-- * Release Date: 
-- *
-- * Author(s): M.Freeman
-- *
-- * Description: Difference Engine Mark 3 Wrapper testbench
-- *
-- * Change History:  $Author: $
-- *                  $Date: $
-- *                  $Revision: $
-- *
-- * Conditions of Use: THIS CODE IS COPYRIGHT AND IS SUPPLIED "AS IS" WITHOUT WARRANTY OF ANY KIND, INCLUDING,
-- *                    BUT NOT LIMITED TO, ANY IMPLIED WARRANTY OF MERCHANTABILITY AND FITNESS FOR A
-- *                    PARTICULAR PURPOSE.
-- *
-- * Notes:
-- *  
-- =============================================================================================================

LIBRARY ieee;
USE ieee.std_logic_1164.ALL;
USE ieee.std_logic_unsigned.ALL;
USE ieee.numeric_std.ALL;
 
ENTITY DE3_Wrapper_tb IS
END DE3_Wrapper_tb;
 
ARCHITECTURE DE3_Wrapper_tb_arch OF DE3_Wrapper_tb IS 
 
  --
  -- Component Declaration for the Unit Under Test (UUT)
  -- 
  
  COMPONENT DE3_Wrapper
  PORT(
    clk : IN  STD_LOGIC;
    clr : IN  STD_LOGIC;
    tx  : OUT  STD_LOGIC );
  END COMPONENT;
    
  --
  --Constants
  --
  
  CONSTANT WIDTH : INTEGER := 104;
  
  --
  --Inputs
  --
  
  SIGNAL clk : STD_LOGIC := '0';
  SIGNAL clr : STD_LOGIC := '0';

  --
 	--Outputs
  --
  
  SIGNAL tx : STD_LOGIC;

  --
  -- Clock period definitions
  --
  
  CONSTANT clk_period : time := 125 ns;
 
BEGIN

  --
	-- Instantiate the Unit Under Test (UUT)
  --
  
  uut: DE3_Wrapper
  PORT MAP (
    clk => clk,
    clr => clr,
    tx  => tx );

  --
  -- Clock process definitions
  --
  
  clk_process :PROCESS
  BEGIN
    clk <= '0';
	  WAIT FOR clk_period / 2;
		clk <= '1';
	  WAIT FOR clk_period / 2;
  END PROCESS;
 
  --
  -- Reset process definitions
  --
  
  clr_process :PROCESS
  BEGIN
    clr <= '0';
	  WAIT FOR clk_period*10;
		clr <= '1';
	  WAIT;
  END PROCESS;

END DE3_Wrapper_tb_arch;
