-- =============================================================================================================
-- *
-- * Copyright (c) University of York
-- *
-- * File Name: mux.vhd
-- *
-- * Version: V1.0
-- *
-- * Release Date: 
-- *
-- * Author(s): M.Freeman
-- *
-- * Description: Data multiplexer
-- *
-- * Change History:  $Author: $
-- *                  $Date: $
-- *                  $Revision: $
-- *
-- * Conditions of Use: THIS CODE IS COPYRIGHT AND IS SUPPLIED "AS IS" WITHOUT WARRANTY OF ANY KIND, INCLUDING,
-- *                    BUT NOT LIMITED TO, ANY IMPLIED WARRANTY OF MERCHANTABILITY AND FITNESS FOR A
-- *                    PARTICULAR PURPOSE.
-- *
-- * Notes:
-- *  
-- =============================================================================================================

LIBRARY IEEE;
USE IEEE.STD_LOGIC_1164.ALL;

ENTITY mux IS
PORT ( 
  din_A  : IN STD_LOGIC_VECTOR( 7 DOWNTO 0 );
  din_B  : IN STD_LOGIC_VECTOR( 7 DOWNTO 0 );
  din_C  : IN STD_LOGIC_VECTOR( 7 DOWNTO 0 );
  din_D  : IN STD_LOGIC_VECTOR( 7 DOWNTO 0 );
  din_E  : IN STD_LOGIC_VECTOR( 7 DOWNTO 0 );
  din_F  : IN STD_LOGIC_VECTOR( 7 DOWNTO 0 );
  din_G  : IN STD_LOGIC_VECTOR( 7 DOWNTO 0 );
  din_H  : IN STD_LOGIC_VECTOR( 7 DOWNTO 0 );
  din_I  : IN STD_LOGIC_VECTOR( 7 DOWNTO 0 );
  din_J  : IN STD_LOGIC_VECTOR( 7 DOWNTO 0 );
  din_K  : IN STD_LOGIC_VECTOR( 7 DOWNTO 0 );
  din_L  : IN STD_LOGIC_VECTOR( 7 DOWNTO 0 );
  din_M  : IN STD_LOGIC_VECTOR( 7 DOWNTO 0 );
  dout   : OUT STD_LOGIC_VECTOR( 7 DOWNTO 0 );
  sel    : IN STD_LOGIC_VECTOR( 3 DOWNTO 0 ) );
END mux;

ARCHITECTURE mux_arch OF mux IS
BEGIN

  mux: PROCESS(sel, din_A, din_B, din_C, din_D, din_E, din_F,
                    din_G, din_H, din_I, din_J, din_K, din_L,
                    din_M )
  BEGIN
    CASE ( sel ) IS
      WHEN "0000" => dout <= din_A;
      WHEN "0001" => dout <= din_B;    
      WHEN "0010" => dout <= din_C;
      WHEN "0011" => dout <= din_D;
      WHEN "0100" => dout <= din_E;    
      WHEN "0101" => dout <= din_F;
      WHEN "0110" => dout <= din_G;
      WHEN "0111" => dout <= din_H;    
      WHEN "1000" => dout <= din_I;
      WHEN "1001" => dout <= din_J;
      WHEN "1010" => dout <= din_K;    
      WHEN "1011" => dout <= din_L;
      WHEN "1100" => dout <= din_M;	
      WHEN OTHERS => dout <= din_A; 
    END CASE;
  END PROCESS;

END mux_arch;
